local assets=
{
    Asset("ANIM", "anim/shadowaxe.zip"),
    Asset("ANIM", "anim/swap_shadowaxe.zip"),
 
    Asset("ATLAS", "images/inventoryimages/shadowaxe.xml"),
    Asset("IMAGE", "images/inventoryimages/shadowaxe.tex"),
}
prefabs = {
}
local function onfinished(inst)
    inst:Remove()
end

local function fn(sim)
    local inst = CreateEntity()
    local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    local sound = inst.entity:AddSoundEmitter()

    local function OnEquip(inst, owner)
        owner.AnimState:OverrideSymbol("swap_object", "swap_shadowaxe", "swap_shadowaxe")
        owner.AnimState:Show("ARM_carry")
        owner.AnimState:Hide("ARM_normal")
    end
 
    local function OnUnequip(inst, owner)
        owner.AnimState:Hide("ARM_carry")
        owner.AnimState:Show("ARM_normal")
    end
 

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddNetwork()
    
    MakeInventoryPhysics(inst)
     
    anim:SetBank("shadowaxe")
    anim:SetBuild("shadowaxe")
    anim:PlayAnimation("idle")

    inst:AddTag("sharp")

                if not TheWorld.ismastersim then
            return inst
           end
            inst.entity:SetPristine()

    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(40)

    inst:AddComponent("tool")
    inst.components.tool:SetAction(ACTIONS.CHOP, 2)
 
    inst:AddComponent("inspectable")
     
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.imagename = "shadowaxe"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/shadowaxe.xml"
     
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip(OnEquip)
    inst.components.equippable:SetOnUnequip(OnUnequip)

    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(500)
    inst.components.finiteuses:SetUses(500)
    inst.components.finiteuses:SetOnFinished(onfinished)

            MakeHauntableLaunch(inst)
 
    return inst
end
return  Prefab("common/inventory/shadowaxe", fn, assets, prefabs)