
local MakePlayerCharacter = require "prefabs/player_common"



-- FOODTYPE.SHADOW = "NIGHTMAREFUEL"

local assets = {
    Asset("SCRIPT", "scripts/prefabs/player_common.lua"),
	Asset( "ANIM", "anim/shadowwilson_beard.zip" ),
	 Asset( "ANIM", "anim/player_basic.zip" ),        
	 Asset( "ANIM", "anim/player_idles_shiver.zip" ),        
	 Asset( "ANIM", "anim/player_actions.zip" ),        
	 Asset( "ANIM", "anim/player_actions_axe.zip" ),        
	 Asset( "ANIM", "anim/player_actions_pickaxe.zip" ),        
	 Asset( "ANIM", "anim/player_actions_shovel.zip" ),        
	 Asset( "ANIM", "anim/player_actions_blowdart.zip" ),        
	 Asset( "ANIM", "anim/player_actions_eat.zip" ),        
	 Asset( "ANIM", "anim/player_actions_item.zip" ),        
	 Asset( "ANIM", "anim/player_actions_uniqueitem.zip" ),        
	 Asset( "ANIM", "anim/player_actions_bugnet.zip" ),        
	 Asset( "ANIM", "anim/player_actions_fishing.zip" ),        
	 Asset( "ANIM", "anim/player_actions_boomerang.zip" ),        
	 Asset( "ANIM", "anim/player_bush_hat.zip" ),        
	 Asset( "ANIM", "anim/player_attacks.zip" ),        
	 Asset( "ANIM", "anim/player_idles.zip" ),        
	 Asset( "ANIM", "anim/player_rebirth.zip" ),        
	 Asset( "ANIM", "anim/player_jump.zip" ),        
	 Asset( "ANIM", "anim/player_amulet_resurrect.zip" ),        
	 Asset( "ANIM", "anim/player_teleport.zip" ),        
	 Asset( "ANIM", "anim/wilson_fx.zip" ),        
	 Asset( "ANIM", "anim/player_one_man_band.zip" ),        
	 Asset( "ANIM", "anim/shadow_hands.zip" ),        
	 Asset( "SOUND", "sound/sfx.fsb" ),        
	 Asset( "SOUND", "sound/wilson.fsb" ), 	 
	 Asset( "ANIM", "anim/shadowwilson.zip" ),        
	 Asset( "ANIM", "anim/ghost_shadowwilson_build.zip" ),        
	 
}


local prefabs = {"nightmarefuel", "shadowaxe",}

-- stat differences night/day
local function updatestats(inst)
	local health_percent = inst.components.health:GetPercent()

    if TheWorld.state.isday then
		if inst.strength == "mighty" then
			
			inst.components.combat.damagemultiplier = 0.75
			inst.components.locomotor.walkspeed = (TUNING.WILSON_WALK_SPEED * 0.8)
			inst.components.locomotor.runspeed = (TUNING.WILSON_RUN_SPEED * 0.8)
		elseif inst.strength == "normal" then
			inst.components.combat.damagemultiplier = 0.75
			inst.components.locomotor.walkspeed = (TUNING.WILSON_WALK_SPEED * 1)
			inst.components.locomotor.runspeed = (TUNING.WILSON_RUN_SPEED * 1)
		elseif inst.strength == "wimpy" then
			inst.components.combat.damagemultiplier = 0.75
			inst.components.locomotor.walkspeed = (TUNING.WILSON_WALK_SPEED * 1.6)
			inst.components.locomotor.runspeed = (TUNING.WILSON_RUN_SPEED * 1.6)
			
		end		
		
	elseif TheWorld.state.isdusk then
        if inst.strength == "mighty" then 
			inst.components.combat.damagemultiplier = 1
			inst.components.locomotor.walkspeed = (TUNING.WILSON_WALK_SPEED * 0.8)
			inst.components.locomotor.runspeed = (TUNING.WILSON_RUN_SPEED * 0.8)
		elseif inst.strength == "normal" then
			inst.components.combat.damagemultiplier = 1
			inst.components.locomotor.walkspeed = (TUNING.WILSON_WALK_SPEED * 1)
			inst.components.locomotor.runspeed = (TUNING.WILSON_RUN_SPEED * 1)
		elseif inst.strength == "wimpy" then
			inst.components.combat.damagemultiplier = 1
			inst.components.locomotor.walkspeed = (TUNING.WILSON_WALK_SPEED * 1.6)
			inst.components.locomotor.runspeed = (TUNING.WILSON_RUN_SPEED * 1.6)
			
		end
		
    elseif TheWorld.state.isnight then
		-- if GetClock():GetMoonPhase() == "full" then
		--	inst.components.combat.damagemultiplier = 2.0
		--	inst.components.locomotor.walkspeed = (TUNING.WILSON_WALK_SPEED * 1.8)
		--	inst.components.locomotor.runspeed = (TUNING.WILSON_RUN_SPEED * 1.8)
			
        -- else
		if inst.strength == "mighty" then
			inst.components.combat.damagemultiplier = 1.25
			inst.components.locomotor.walkspeed = (TUNING.WILSON_WALK_SPEED * 0.8)
			inst.components.locomotor.runspeed = (TUNING.WILSON_RUN_SPEED * 0.8)
		elseif inst.strength == "normal" then	
			inst.components.combat.damagemultiplier = 1.25
			inst.components.locomotor.walkspeed = (TUNING.WILSON_WALK_SPEED * 1)
			inst.components.locomotor.runspeed = (TUNING.WILSON_RUN_SPEED * 1)
		elseif inst.strength == "wimpy" then
			inst.components.combat.damagemultiplier = 1.25
			inst.components.locomotor.walkspeed = (TUNING.WILSON_WALK_SPEED * 1.6)
			inst.components.locomotor.runspeed = (TUNING.WILSON_RUN_SPEED * 1.6)
			
		end
		

    end
	
end


local function onhungerchange(inst, data)

	if inst.strength == "mighty" then
		if inst.components.hunger.current < 120 then
			
			inst.strength = "normal"
			inst.components.talker:Say("I'm starting to get hungry.")

		end
	elseif inst.strength == "wimpy" then
		if inst.components.hunger.current > 55 then

			inst.strength = "normal"
			inst.components.talker:Say("I need more food!")

		end
	else
		if inst.components.hunger.current > 130 then
			inst.strength = "mighty"
			inst.components.talker:Say("I'm feeling full and functional.")


		elseif inst.components.hunger.current < 15 then
			inst.strength = "wimpy"
			inst.components.talker:Say("I'm going to waste away if I don't eat.")

		end
	end
	
	
	updatestats(inst)
end



-- Custom starting items
local start_inv = {"shadowaxe",}

-- When the character is revived from human
local function onbecamehuman(inst)
	-- Set speed when reviving from ghost (optional)
	inst.components.locomotor:SetExternalSpeedMultiplier(inst, "shadowwilson_speed_mod", 1)
end


local function onbecameghost(inst)
	-- Remove speed modifier when becoming a ghost
   inst.components.locomotor:RemoveExternalSpeedMultiplier(inst, "shadowwilson_speed_mod")
end

local function UpdateNightVision(inst, phase)
	local enable = phase == "night"
	inst:DoTaskInTime(enable and 0 or 1, function(inst)
		inst.components.playervision:ForceNightVision(enable)
		inst.components.playervision:SetCustomCCTable(enable and {} or nil)
	end)
end

local function OnInitNightVision(inst)
	if TheWorld.ismastersim or inst.HUD then
		inst:WatchWorldState("phase", UpdateNightVision)
		UpdateNightVision(inst, TheWorld.state.phase)
	end
end

-- When loading or spawning the character
local function onload(inst)
    inst:ListenForEvent("ms_respawnedfromghost", onbecamehuman)
    inst:ListenForEvent("ms_becameghost", onbecameghost)

    if inst:HasTag("playerghost") then
        onbecameghost(inst)
    else
        onbecamehuman(inst)
    end
end

-- This initializes for both the server and client. Tags can be added here.
local common_postinit = function(inst) 
	-- Minimap icon
	inst.MiniMapEntity:SetIcon( "shadowwilson.tex" )
	
	local function common_postinit(inst)
	inst:DoTaskInTime(0, OnInitNightVision)
end
end

local function common_postinit(inst)
	inst:DoTaskInTime(0, OnInitNightVision)
end

local function OnResetBeard(inst)    
inst.AnimState:ClearOverrideSymbol("beard")end --tune the beard economy
local BEARD_DAYS = { 4, 8, 16 }local BEARD_BITS = { 1, 3,  9 } 
local function OnGrowShortBeard(inst)    
inst.AnimState:OverrideSymbol("beard", "shadowwilson_beard", "beard_short")    
inst.components.beard.bits = BEARD_BITS[1]end local function OnGrowMediumBeard(inst)    
inst.AnimState:OverrideSymbol("beard", "shadowwilson_beard", "beard_medium")    
inst.components.beard.bits = BEARD_BITS[2]end local function OnGrowLongBeard(inst)    
inst.AnimState:OverrideSymbol("beard", "shadowwilson_beard", "beard_long")    
inst.components.beard.bits = BEARD_BITS[3]end

-- This initializes for the server only. Components are added here.
local master_postinit = function(inst)

	 inst:AddComponent("beard")    
	 inst.components.beard.onreset = OnResetBeard    
	 inst.components.beard.prize = "nightmarefuel"    
	 inst.components.beard:AddCallback(BEARD_DAYS[1], OnGrowShortBeard)    
	 inst.components.beard:AddCallback(BEARD_DAYS[2], OnGrowMediumBeard)    
	 inst.components.beard:AddCallback(BEARD_DAYS[3], OnGrowLongBeard)
	
	-- choose which sounds this character will play
	inst.soundsname = "wilson"
	
	-- Uncomment if "wathgrithr"(Wigfrid) or "webber" voice is used
    --inst.talker_path_override = "dontstarve_DLC001/characters/"
	
	-- default hunger level
	inst.strength = "normal"
	inst.components.hunger.current = 150

-- Stats varies day/night
	inst:ListenForEvent( "dusktime", function() updatestats(inst) end , GetWorld())
    inst:ListenForEvent( "daytime", function() updatestats(inst) end , GetWorld())
    inst:ListenForEvent( "nighttime", function() updatestats(inst) end , GetWorld())

-- Increase damage buff w/ hunger decrease when starving
inst:ListenForEvent("hungerdelta", function(inst, data)
	local damagepercent = data.newpercent - .7
	if damagepercent >= 0 then--ranges from +0% to +30% damage buff
		inst.components.combat.damagemultiplier = 1 + damagepercent-- 1 + X, change the 1 to the base damage your character has if any
	end
end)

inst:ListenForEvent("attacked", function(inst, data)
	local hunger = inst.components.hunger and inst.components.hunger:GetPercent() or nil
	if hunger and hunger <= 0.3 and data.damage ~= 0 then--ranges from 0% to 30% extra damage
		local extradamage = data.damage * (.3 - hunger)
		inst.components.combat:GetAttacked(data.attacker, extradamage, data.weapon, data.stimuli)
	end
end)


	--Update hunger status
	inst:ListenForEvent("hungerdelta", onhungerchange)
    updatestats(inst)

	-- Stats	
	inst.components.health:SetMaxHealth(120)
	inst.components.hunger:SetMax(150)
	inst.components.sanity:SetMax(120)
	
inst:AddTag"monster"

inst.components.sanity.neg_aura_mult = -TUNING.WENDY_SANITY_MULT

inst:ListenForEvent("startstarving", function(inst)
	if inst.components.health then
		inst.components.health:Kill()
	end
end)

inst.components.sanity.custom_rate_fn = function(inst)
	local light_delta = 0
	if TheWorld.state.isday then
		light_delta = TUNING.SANITY_NIGHT_MID
	elseif TheWorld.state.isnight then
		light_delta = TUNING.DAPPERNESS_MED
	end
	return light_delta
end

    --[[	Ability to eat nightmarefuel and flowers.	]]
--    inst.components.eater:SetDiet( { FOODGROUP.OMNI }, { FOODTYPE.SHADOW } )
--    inst.components.eater:SetOnEatFn( oneat )

	inst.components.beard.insulation_factor = -1
	
inst.components.sanity.night_drain_mult = 0

	-- Hunger rate (optional)
	inst.components.hunger.hungerrate = 1 * TUNING.WILSON_HUNGER_RATE
	
	inst.OnLoad = onload
    inst.OnNewSpawn = onload
	
end


return MakePlayerCharacter("shadowwilson", prefabs, assets, common_postinit, master_postinit, start_inv)
